package com.liang.dao;

import com.liang.entity.PrjContacts;
import org.apache.ibatis.annotations.Param;
import org.springframework.data.domain.Pageable;

import java.util.List;

/**
 * (PrjContacts)表数据库访问层
 *
 * @author makejava
 * @since 2023-04-11 15:04:32
 */
public interface PrjContactsDao {

    /**
     * 通过ID查询单条数据
     *
     * @param id 主键
     * @return 实例对象
     */
    PrjContacts queryById(Integer id);

    /**
     * 查询指定行数据
     *
     * @param prjContacts 查询条件
     * @param pageable    分页对象
     * @return 对象列表
     */
    List<PrjContacts> queryAllByLimit(PrjContacts prjContacts, @Param("pageable") Pageable pageable);

    /**
     * 统计总行数
     *
     * @param prjContacts 查询条件
     * @return 总行数
     */
    long count(PrjContacts prjContacts);

    /**
     * 新增数据
     *
     * @param prjContacts 实例对象
     * @return 影响行数
     */
    int insert(PrjContacts prjContacts);

    /**
     * 批量新增数据（MyBatis原生foreach方法）
     *
     * @param entities List<PrjContacts> 实例对象列表
     * @return 影响行数
     */
    int insertBatch(@Param("entities") List<PrjContacts> entities);

    /**
     * 批量新增或按主键更新数据（MyBatis原生foreach方法）
     *
     * @param entities List<PrjContacts> 实例对象列表
     * @return 影响行数
     * @throws org.springframework.jdbc.BadSqlGrammarException 入参是空List的时候会抛SQL语句错误的异常，请自行校验入参
     */
    int insertOrUpdateBatch(@Param("entities") List<PrjContacts> entities);

    /**
     * 修改数据
     *
     * @param prjContacts 实例对象
     * @return 影响行数
     */
    int update(PrjContacts prjContacts);

    /**
     * 通过主键删除数据
     *
     * @param id 主键
     * @return 影响行数
     */
    int deleteById(Integer id);

    /**
     * 删除项目联系方式
     *
     * @param xm
     * @return
     */
    int deleteByXm(Integer xm);

    /**
     * 删除项目联系方式
     *
     * @param xmList
     * @return
     */
    int batchDeleteByXm(List<Integer> xmList);

    /**
     * 根据项目获取联系方式
     *
     * @param xm
     * @return
     */
    List<PrjContacts> getContactList(Integer xm);

    /**
     * 批量删除联系方式
     *
     * @param idList
     * @return
     */
    int batchDelete(List<Integer> idList);
}

